import _construct from "@babel/runtime/helpers/esm/construct";
import React from 'react';
import { Spring } from '../utils/spring';
import useGetLatest from './useGetLatest';
export function useSpring(value, config, cb, immediate) {
  var springRef = React.useRef(_construct(Spring, [value].concat(config)));
  var getImmediate = useGetLatest(immediate);

  var _useRaf = useRaf(function () {
    cb(springRef.current.x());
    return springRef.current.done();
  }),
      startRaf = _useRaf[0],
      stopRaf = _useRaf[1];

  React.useEffect(function () {
    if (springRef.current.endPosition !== value) {
      springRef.current.setEnd(value, getImmediate());
      startRaf();
    }
  }, [getImmediate, startRaf, value]);
  React.useEffect(function () {
    return function () {
      stopRaf();
    };
  }, [stopRaf]);
  return springRef.current;
}
export function useRaf(callback) {
  var raf = React.useRef(null);
  var rafCallback = React.useRef(callback);
  rafCallback.current = callback;
  var tick = React.useCallback(function () {
    if (rafCallback.current()) return;
    raf.current = requestAnimationFrame(tick);
  }, []);
  return [React.useMemo(function () {
    return tick;
  }, [tick]), React.useMemo(function () {
    return function () {
      return raf.current && cancelAnimationFrame(raf.current);
    };
  }, [])];
}